#!/nfs-home/mjones/usr/bin/ruby -w

def txt_to_xml(photo)
  text = IO.readlines(photo).join('')

  protect_cdata(text)

  text = <<"EOF"
<?xml version="1.0" ?>
<photo>
#{text}
</photo>
EOF

  return text
end

def protect_cdata(text)
  text.gsub!(%r!<(title|description|date|event|location|
                  people|macro|outdoor|wallpaper)>
                (.*?)
                </\1>!mx) do |match|
    element, content = $1, $2.strip
    if content =~ /[;<>]/
      <<EOF
<#{element}>
    <![CDATA[  <!
#{content}
    ]]>
</#{element}>
EOF
    else
      match
    end
  end
end

$stdin.readlines.each do |photo|
  photo.chomp!
  raise "huh" unless photo =~ %r!^(.*)/(.*)\.txt$!
  path, base = $1, $2
  newfile = base + '.xml'

  print photo + ' ... '
  xml = File.new(path + '/' + newfile, 'w')
  xml.puts txt_to_xml(photo)
  puts "done"
end

